---
product: "AG Charts"
title: "Series Bars"
description: "JavaScript charts support bar styling including fixed width, width ratio, band alignment and actual vs target visualisations."
framework: javascript
version: "14.2.0"
related:
    - title: "Cross Lines"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-cross-lines/"
    - title: "Legend"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/legend/"
    - title: "Formatters"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/formatters/"
    - title: "Stylers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/stylers/"
    - title: "Series Fills"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/fills/"
    - title: "Series Labels"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/series-labels/"
    - title: "Series Markers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/markers/"
    - title: "Style Segments"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/style-segments/"
    - title: "Annotations"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/annotations/"
    - title: "Background Regions"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/background-regions/"
    - title: "Colour Scale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/colour-scale/"
    - title: "Error Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/javascript/error-bars/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Series Bars

Data points can be represented by vertical or horizontal bars in many series types, such as [Bar](https://www.ag-grid.com/charts/archive/14.2.0/javascript/bar-series/), [Range Bar](https://www.ag-grid.com/charts/archive/14.2.0/javascript/range-bar-series/), [Waterfall](https://www.ag-grid.com/charts/archive/14.2.0/javascript/waterfall-series/) and [Box Plot](https://www.ag-grid.com/charts/archive/14.2.0/javascript/box-plot-series/).

Styling and customisation options such as `fill`, `stroke` and `cornerRadius` are configurable within each series. See [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/javascript/bars/#api-reference) for details.

## Fixed Width

Use the `width` option to set a fixed pixel width for each bar.

#### Fixed Width

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  ScrollbarModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
  ScrollbarModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  title: {
    text: "Quarterly Revenue by Product Line",
  },
  scrollbar: { enabled: true },
  series: [
    {
      type: "bar",
      xKey: "quarter",
      yKey: "software",
      yName: "Software",
      width: 30,
    },
    {
      type: "bar",
      xKey: "quarter",
      yKey: "hardware",
      yName: "Hardware",
      width: 30,
    },
    {
      type: "bar",
      xKey: "quarter",
      yKey: "services",
      yName: "Services",
      width: 30,
    },
  ],
  axes: {
    x: {
      type: "category",
    },
    y: {
      type: "number",
      label: {
        formatter: ({ value }) => `$${(value / 1000).toFixed(1)}B`,
      },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function setWidthMode(event: Event) {
  const fixedWidth = (event.target as HTMLInputElement).value === "fixed";
  for (const series of options.series ?? []) {
    if (!("width" in series)) continue;
    series.width = fixedWidth
      ? Number(document.getElementById("fixedWidthSliderValue")!.innerHTML)
      : undefined;
  }

  (document.getElementById("fixedWidthGroup") as HTMLFieldSetElement).disabled =
    !fixedWidth;
  chart.update(options);
}

function updateFixedWidth(event: any) {
  const value = Number(event.target?.value);
  for (const series of options.series ?? []) {
    if (!("width" in series)) continue;
    series.width = value;
  }

  document.getElementById("fixedWidthSliderValue")!.innerHTML = String(value);
  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).setWidthMode = setWidthMode;
  (<any>window).updateFixedWidth = updateFixedWidth;
}
```

[Live example: Fixed Width](https://www.ag-grid.com/charts/archive/14.2.0/typescript/bars/examples/fixed-width-clipping/)

```js
{
    series: [
        {
            type: 'bar',
            width: 30,
        },
    ],
}
```

In this example:

- Each bar in the series has a fixed width of 30 pixels.
- Toggle the fixed width off to let bars automatically size to fit the series area.
- Use the slider to change the width in pixels.

When using fixed width bars:

- Resizing the chart does not affect the width of the bars.
- The bars will be clipped if the fixed width exceeds the available space in the series area.
- Clipped bars can be viewed using the [Scrollbar](https://www.ag-grid.com/charts/archive/14.2.0/javascript/scrollbar/), [Navigator](https://www.ag-grid.com/charts/archive/14.2.0/javascript/navigator/) or [Zoom](https://www.ag-grid.com/charts/archive/14.2.0/javascript/zoom/) controls.

### Band Alignment

Use the `bandAlignment` option on a [Category](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-types/#category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/#unit-time) or [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/#ordinal-time) axis to align fixed width bars.

#### Band Alignment

```ts
import {
  AgBandAlignment,
  AgCartesianChartOptions,
  AgCategoryAxisOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";
import { DataType, getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions<DataType> = {
  data: getData(),
  title: {
    text: "Total Visitors to Museums and Galleries",
  },
  footnote: {
    text: "Source: Department for Digital, Culture, Media & Sport",
  },
  series: [
    {
      type: "bar",
      xKey: "quarter",
      yKey: "museums",
      yName: "Museums",
      width: 10,
    },
    {
      type: "bar",
      xKey: "quarter",
      yKey: "galleries",
      yName: "Galleries",
      width: 10,
    },
    {
      type: "bar",
      xKey: "quarter",
      yKey: "heritage",
      yName: "Heritage Sites",
      width: 10,
    },
  ],
  axes: {
    x: {
      type: "category",
      bandAlignment: "start",
    },
    y: {
      type: "number",
      title: {
        text: "Total Visitors (Millions)",
      },
    },
  },
  formatter: {
    y(params) {
      const value = params.value as number;
      const millions = value / 1000000;
      const accuracy = ["series-label", "axis-label"].includes(params.source)
        ? 0
        : 1;
      return `${millions.toFixed(accuracy)}M`;
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function bandAlignmentChange(event: Event) {
  const alignment = (event.target as HTMLInputElement).value as AgBandAlignment;
  (options.axes!.x! as AgCategoryAxisOptions).bandAlignment = alignment;

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).bandAlignmentChange = bandAlignmentChange;
}
```

[Live example: Band Alignment](https://www.ag-grid.com/charts/archive/14.2.0/typescript/bars/examples/band-alignment/)

```js
{
    axes: {
        x: {
            type: 'category',
            bandAlignment: 'start',
        },
    },
}
```

In this example:

- The category axis has an initial band alignment of `start`.
- Use the buttons to compare other band alignment options.
  - `justify` - bands are sized to fill the chart width, with the bars centred within each band.
  - `start` - bands are sized to fit the bar width and aligned to the start of the axis.
  - `center` - bands are sized to fit the bar width and centred within the chart width.
  - `end` - bands are sized to fit the bar width and aligned to the end of the axis.

## Width Ratio

Use the `widthRatio` option to set the bar width as a proportion of the default width.

#### Width Ratio

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  RangeBarSeriesModule,
  UnitTimeAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

const data = getData();
ModuleRegistry.registerModules([
  CrosshairModule,
  LegendModule,
  NumberAxisModule,
  RangeBarSeriesModule,
  UnitTimeAxisModule,
]);

const options: AgCartesianChartOptions = {
  title: {
    text: "Australia vs Global Temperature Patterns",
  },
  subtitle: {
    text: "Monthly temperature ranges (2020) showing seasonal variations across regions",
  },
  footnote: {
    text: "Data: World Meteorological Organization. Ranges show typical monthly lows and highs.",
    fontStyle: "italic",
  },
  series: [
    {
      data: data.World,
      type: "range-bar",
      xKey: "month",
      yName: "World",
      yLowKey: "lowTemperature",
      yHighKey: "highTemperature",
      yLowName: "Min Temp",
      yHighName: "Max Temp",
      cornerRadius: 5,
      fill: "transparent",
      strokeWidth: 2,
      strokeOpacity: 0.6,
      highlight: { enabled: false },
    },
    {
      data: data.Australia,
      type: "range-bar",
      xKey: "month",
      yName: "Australia",
      grouped: false,
      widthRatio: 0.4,
      yLowKey: "lowTemperature",
      yHighKey: "highTemperature",
      yLowName: "Min Temp",
      yHighName: "Max Temp",
      cornerRadius: 5,
    },
  ],
  axes: {
    x: {
      type: "unit-time",
      label: {
        formatter: ({ value }) => {
          const date = new Date(value);
          return date.toLocaleDateString("en-US", { month: "short" });
        },
      },
    },
    y: {
      label: {
        formatter: ({ value }) => `${value}°C`,
      },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function updateWidthRatio(event: any) {
  const value = Number(event.target?.value);
  (options.series![1] as any).widthRatio = value;

  document.getElementById("widthRatioSliderValue")!.innerHTML = String(value);
  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).updateWidthRatio = updateWidthRatio;
}
```

[Live example: Width Ratio](https://www.ag-grid.com/charts/archive/14.2.0/typescript/bars/examples/width-ratio/)

```js
{
    series: [
        {
            type: 'range-bar',
            grouped: false,
            widthRatio: 0.4,
        },
    ],
}
```

In this example:

- The World series uses the default width ratio of 1.
- The Australia series has an initial width ratio of 0.4.
- Use the slider to change the width ratio.
- This gives an [Actual vs Target](https://www.ag-grid.com/charts/archive/14.2.0/javascript/bars/#actual-vs-target-bars) style visualisation, with the "World" series as a background reference.

## Actual vs Target Bars

Bars can be layered to create actual vs target comparisons by using `grouped: false` to overlay series.

#### Actual vs Target

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  title: {
    text: "Quarterly Sales vs Target",
  },
  series: [
    {
      type: "bar",
      direction: "horizontal",
      xKey: "quarter",
      yKey: "target",
      yName: "Target",
      grouped: false,
      fillOpacity: 0.3,
      cornerRadius: 3,
      highlight: {
        enabled: false,
      },
    },
    {
      type: "bar",
      direction: "horizontal",
      xKey: "quarter",
      yKey: "actual",
      yName: "Actual",
      grouped: false,
      widthRatio: 0.5,
      cornerRadius: 6,
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Actual vs Target](https://www.ag-grid.com/charts/archive/14.2.0/typescript/bars/examples/actual-target/)

```js
{
    series: [
        {
            type: 'bar',
            yKey: 'target',
            grouped: false,
            fillOpacity: 0.3,
        },
        {
            type: 'bar',
            yKey: 'actual',
            grouped: false,
            widthRatio: 0.5,
        },
    ],
}
```

In this example:

- The Target series uses `grouped: false` to span the full category width as a background bar.
- The Actual series also uses `grouped: false` with a `widthRatio` of 0.5 to appear narrower in front.
- The Target series is specified first in the `series` array so that it appears behind the Actual series.
- The target has reduced `fillOpacity` and highlighting disabled.

### Multiple Metrics

Multiple grouped series can be displayed over a single ungrouped target bar.

#### Multiple Metrics vs Target

```ts
import {
  AgCartesianChartOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  title: {
    text: "Regional Sales vs Target",
  },
  series: [
    {
      type: "bar",
      xKey: "quarter",
      yKey: "target",
      yName: "Target",
      grouped: false,
      fillOpacity: 0.3,
      highlight: {
        enabled: false,
      },
    },
    {
      type: "bar",
      xKey: "quarter",
      yKey: "europe",
      yName: "Europe",
      widthRatio: 0.8,
    },
    {
      type: "bar",
      xKey: "quarter",
      yKey: "asia",
      yName: "Asia",
      widthRatio: 0.8,
    },
  ],
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);
```

[Live example: Multiple Metrics vs Target](https://www.ag-grid.com/charts/archive/14.2.0/typescript/bars/examples/targets-comparisons/)

In this example:

- The "Target" series is ungrouped and spans the full category width as a background reference.
- The "Europe" and "Asia" series are grouped by default, sharing their portion of the category width.
- When a series has `grouped: false`, its `widthRatio` is relative to the full category width.
- When `grouped: true` (the default), `widthRatio` is relative to the automatically calculated width allocated to each series within group.

## Skip Null Bars

Use the `skipNullBars` option on a [Category](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-types/#category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/#unit-time) or [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/#ordinal-time) axis to prevent bars with `null`, `undefined` or missing values from taking up space within each category band. This also closes the gap when a series supplies its own `data` array and a category is absent from it.

#### Skip Null Bars

```ts
import {
  AgCartesianChartOptions,
  AgCategoryAxisOptions,
  AgCharts,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const options: AgCartesianChartOptions = {
  data: getData(),
  title: {
    text: "Quarterly Revenue",
  },
  series: [
    {
      type: "bar",
      xKey: "quarter",
      yKey: "software",
      yName: "Software",
    },
    {
      type: "bar",
      xKey: "quarter",
      yKey: "hardware",
      yName: "Hardware",
    },
    {
      type: "bar",
      xKey: "quarter",
      yKey: "services",
      yName: "Services",
    },
    {
      type: "bar",
      xKey: "quarter",
      yKey: "investments",
      yName: "Investments",
    },
  ],
  axes: {
    x: {
      type: "category",
      skipNullBars: true,
    },
    y: {
      type: "number",
      label: {
        formatter: ({ value }) => `$${(value / 1000).toFixed(1)}B`,
      },
    },
  },
};

options.container = document.getElementById("myChart");

const chart = AgCharts.create(options);

function skipNullBarsChange(event: Event) {
  (options.axes!.x as AgCategoryAxisOptions).skipNullBars =
    (event.target as HTMLInputElement).value === "true";

  chart.update(options);
}

if (typeof window !== "undefined") {
  // Attach external event handlers to window so they can be called from index.html
  (<any>window).skipNullBarsChange = skipNullBarsChange;
}
```

[Live example: Skip Null Bars](https://www.ag-grid.com/charts/archive/14.2.0/typescript/bars/examples/skip-null-bars/)

```js
{
    axes: {
        x: {
            type: 'category',
            skipNullBars: true,
        },
    },
}
```

In this example:

- Various values in the data are set to `null`, `undefined` or missing.
- When an axis has `skipNullBars: true`, bars with `null`, `undefined` or missing values are not represented on the chart.
- Toggle between "Skip Null Bars" and "Show Null Bars" to compare the difference.

## API Reference

#### Bar Options

These properties are common to [Bar](https://www.ag-grid.com/charts/archive/14.2.0/javascript/bar-series/), [Range Bar](https://www.ag-grid.com/charts/archive/14.2.0/javascript/range-bar-series/), [Waterfall](https://www.ag-grid.com/charts/archive/14.2.0/javascript/waterfall-series/) and [Box Plot](https://www.ag-grid.com/charts/archive/14.2.0/javascript/box-plot-series/) series types.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| width | PixelSize |  | Fixed width of each bar in the series. |
| widthRatio | Ratio |  | Ratio of the bandwidth (or specified width) to use for the width for each bar in the series. |
| cornerRadius | PixelSize |  | Apply rounded corners to each bar. |
| fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| fillOpacity | Opacity |  | The opacity of the fill colour. |
| stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |

#### Band Alignment

This property is available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-types/#category), [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/#ordinal-time) and [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/#unit-time) axes.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| bandAlignment | 'justify' \| 'start' \| 'center' \| 'end' | 'justify' | The alignment of bands when used with bar-like series with fixed widths. |

#### Skip Null Bars

This property is available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-types/#category), [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/#ordinal-time) and [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/javascript/axes-time/#unit-time) axes.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| skipNullBars | boolean | false | Set to `true` to prevent bars with `null`, `undefined` or missing values from taking up space in each category. |


---
product: "AG Charts"
title: "Series Bars"
description: "React charts support bar styling including fixed width, width ratio, band alignment and actual vs target visualisations."
framework: react
version: "14.2.0"
related:
    - title: "Cross Lines"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/axes-cross-lines/"
    - title: "Legend"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/legend/"
    - title: "Formatters"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/formatters/"
    - title: "Stylers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/stylers/"
    - title: "Series Fills"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/fills/"
    - title: "Series Labels"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/series-labels/"
    - title: "Series Markers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/markers/"
    - title: "Style Segments"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/style-segments/"
    - title: "Annotations"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/annotations/"
    - title: "Background Regions"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/background-regions/"
    - title: "Colour Scale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/colour-scale/"
    - title: "Error Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/react/error-bars/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Series Bars

Data points can be represented by vertical or horizontal bars in many series types, such as [Bar](https://www.ag-grid.com/charts/archive/14.2.0/react/bar-series/), [Range Bar](https://www.ag-grid.com/charts/archive/14.2.0/react/range-bar-series/), [Waterfall](https://www.ag-grid.com/charts/archive/14.2.0/react/waterfall-series/) and [Box Plot](https://www.ag-grid.com/charts/archive/14.2.0/react/box-plot-series/).

Styling and customisation options such as `fill`, `stroke` and `cornerRadius` are configurable within each series. See [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/react/bars/#api-reference) for details.

## Fixed Width

Use the `width` option to set a fixed pixel width for each bar.

#### Fixed Width

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  ScrollbarModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
  ScrollbarModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    title: {
      text: "Quarterly Revenue by Product Line",
    },
    scrollbar: { enabled: true },
    series: [
      {
        type: "bar",
        xKey: "quarter",
        yKey: "software",
        yName: "Software",
        width: 30,
      },
      {
        type: "bar",
        xKey: "quarter",
        yKey: "hardware",
        yName: "Hardware",
        width: 30,
      },
      {
        type: "bar",
        xKey: "quarter",
        yKey: "services",
        yName: "Services",
        width: 30,
      },
    ],
    axes: {
      x: {
        type: "category",
      },
      y: {
        type: "number",
        label: {
          formatter: ({ value }) => `$${(value / 1000).toFixed(1)}B`,
        },
      },
    },
  });

  const setWidthMode = (event: Event) => {
    const nextOptions = clone(options);

    const fixedWidth = (event.target as HTMLInputElement).value === "fixed";
    for (const series of nextOptions.series ?? []) {
      if (!("width" in series)) continue;
      series.width = fixedWidth
        ? Number(document.getElementById("fixedWidthSliderValue")!.innerHTML)
        : undefined;
    }

    (
      document.getElementById("fixedWidthGroup") as HTMLFieldSetElement
    ).disabled = !fixedWidth;

    setOptions(nextOptions);
  };

  const updateFixedWidth = (event: any) => {
    const nextOptions = clone(options);

    const value = Number(event.target?.value);
    for (const series of nextOptions.series ?? []) {
      if (!("width" in series)) continue;
      series.width = value;
    }

    document.getElementById("fixedWidthSliderValue")!.innerHTML = String(value);

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <span>Bar Width:</span>
          <div className="button-group" role="group" aria-label="Bar Width">
            <input
              type="radio"
              id="width-auto"
              name="width"
              defaultValue="auto"
              onChange={(event) => setWidthMode(event)}
            />
            <label htmlFor="width-auto">Auto</label>
            <input
              type="radio"
              id="width-fixed"
              name="width"
              defaultValue="fixed"
              defaultChecked
              onChange={(event) => setWidthMode(event)}
            />
            <label htmlFor="width-fixed">Fixed</label>
          </div>
          <fieldset id="fixedWidthGroup" className="control-group">
            <label htmlFor="fixedWidthSliderInput" className="gap-left">
              Fixed Width:
            </label>
            <input
              type="range"
              id="fixedWidthSliderInput"
              min="5"
              max="60"
              defaultValue="30"
              step="1"
              onInput={(event) => updateFixedWidth(event)}
              onChange={(event) => updateFixedWidth(event)}
            />
            <span id="fixedWidthSliderValue">30</span>
          </fieldset>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Fixed Width](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/bars/examples/fixed-width-clipping/)

```js
{
    series: [
        {
            type: 'bar',
            width: 30,
        },
    ],
}
```

In this example:

- Each bar in the series has a fixed width of 30 pixels.
- Toggle the fixed width off to let bars automatically size to fit the series area.
- Use the slider to change the width in pixels.

When using fixed width bars:

- Resizing the chart does not affect the width of the bars.
- The bars will be clipped if the fixed width exceeds the available space in the series area.
- Clipped bars can be viewed using the [Scrollbar](https://www.ag-grid.com/charts/archive/14.2.0/react/scrollbar/), [Navigator](https://www.ag-grid.com/charts/archive/14.2.0/react/navigator/) or [Zoom](https://www.ag-grid.com/charts/archive/14.2.0/react/zoom/) controls.

### Band Alignment

Use the `bandAlignment` option on a [Category](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-types/#category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/#unit-time) or [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/#ordinal-time) axis to align fixed width bars.

#### Band Alignment

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgBandAlignment,
  AgCartesianChartOptions,
  AgCategoryAxisOptions,
  BarSeriesModule,
  CategoryAxisModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";
import { DataType, getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions<DataType>>({
    data: getData(),
    title: {
      text: "Total Visitors to Museums and Galleries",
    },
    footnote: {
      text: "Source: Department for Digital, Culture, Media & Sport",
    },
    series: [
      {
        type: "bar",
        xKey: "quarter",
        yKey: "museums",
        yName: "Museums",
        width: 10,
      },
      {
        type: "bar",
        xKey: "quarter",
        yKey: "galleries",
        yName: "Galleries",
        width: 10,
      },
      {
        type: "bar",
        xKey: "quarter",
        yKey: "heritage",
        yName: "Heritage Sites",
        width: 10,
      },
    ],
    axes: {
      x: {
        type: "category",
        bandAlignment: "start",
      },
      y: {
        type: "number",
        title: {
          text: "Total Visitors (Millions)",
        },
      },
    },
    formatter: {
      y(params) {
        const value = params.value as number;
        const millions = value / 1000000;
        const accuracy = ["series-label", "axis-label"].includes(params.source)
          ? 0
          : 1;
        return `${millions.toFixed(accuracy)}M`;
      },
    },
  });

  const bandAlignmentChange = (event: Event) => {
    const nextOptions = clone(options);

    const alignment = (event.target as HTMLInputElement)
      .value as AgBandAlignment;
    (nextOptions.axes!.x! as AgCategoryAxisOptions).bandAlignment = alignment;

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div
            className="button-group"
            role="group"
            aria-label="Band Alignment"
          >
            <input
              type="radio"
              id="band-alignment-justify"
              name="band-alignment"
              defaultValue="justify"
              onChange={(event) => bandAlignmentChange(event)}
            />
            <label htmlFor="band-alignment-justify">Justify</label>
            <input
              type="radio"
              id="band-alignment-start"
              name="band-alignment"
              defaultValue="start"
              defaultChecked
              onChange={(event) => bandAlignmentChange(event)}
            />
            <label htmlFor="band-alignment-start">Start</label>
            <input
              type="radio"
              id="band-alignment-center"
              name="band-alignment"
              defaultValue="center"
              onChange={(event) => bandAlignmentChange(event)}
            />
            <label htmlFor="band-alignment-center">Center</label>
            <input
              type="radio"
              id="band-alignment-end"
              name="band-alignment"
              defaultValue="end"
              onChange={(event) => bandAlignmentChange(event)}
            />
            <label htmlFor="band-alignment-end">End</label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Band Alignment](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/bars/examples/band-alignment/)

```js
{
    axes: {
        x: {
            type: 'category',
            bandAlignment: 'start',
        },
    },
}
```

In this example:

- The category axis has an initial band alignment of `start`.
- Use the buttons to compare other band alignment options.
  - `justify` - bands are sized to fill the chart width, with the bars centred within each band.
  - `start` - bands are sized to fit the bar width and aligned to the start of the axis.
  - `center` - bands are sized to fit the bar width and centred within the chart width.
  - `end` - bands are sized to fit the bar width and aligned to the end of the axis.

## Width Ratio

Use the `widthRatio` option to set the bar width as a proportion of the default width.

#### Width Ratio

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  RangeBarSeriesModule,
  UnitTimeAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

const data = getData();
ModuleRegistry.registerModules([
  CrosshairModule,
  LegendModule,
  NumberAxisModule,
  RangeBarSeriesModule,
  UnitTimeAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    title: {
      text: "Australia vs Global Temperature Patterns",
    },
    subtitle: {
      text: "Monthly temperature ranges (2020) showing seasonal variations across regions",
    },
    footnote: {
      text: "Data: World Meteorological Organization. Ranges show typical monthly lows and highs.",
      fontStyle: "italic",
    },
    series: [
      {
        data: data.World,
        type: "range-bar",
        xKey: "month",
        yName: "World",
        yLowKey: "lowTemperature",
        yHighKey: "highTemperature",
        yLowName: "Min Temp",
        yHighName: "Max Temp",
        cornerRadius: 5,
        fill: "transparent",
        strokeWidth: 2,
        strokeOpacity: 0.6,
        highlight: { enabled: false },
      },
      {
        data: data.Australia,
        type: "range-bar",
        xKey: "month",
        yName: "Australia",
        grouped: false,
        widthRatio: 0.4,
        yLowKey: "lowTemperature",
        yHighKey: "highTemperature",
        yLowName: "Min Temp",
        yHighName: "Max Temp",
        cornerRadius: 5,
      },
    ],
    axes: {
      x: {
        type: "unit-time",
        label: {
          formatter: ({ value }) => {
            const date = new Date(value);
            return date.toLocaleDateString("en-US", { month: "short" });
          },
        },
      },
      y: {
        label: {
          formatter: ({ value }) => `${value}°C`,
        },
      },
    },
  });

  const updateWidthRatio = (event: any) => {
    const nextOptions = clone(options);

    const value = Number(event.target?.value);
    (nextOptions.series![1] as any).widthRatio = value;

    document.getElementById("widthRatioSliderValue")!.innerHTML = String(value);

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <label htmlFor="widthRatioSliderInput">Width Ratio:</label>
          <input
            type="range"
            id="widthRatioSliderInput"
            min="0.1"
            max="1.0"
            defaultValue="0.4"
            step="0.1"
            onInput={(event) => updateWidthRatio(event)}
            onChange={(event) => updateWidthRatio(event)}
          />
          <span id="widthRatioSliderValue">0.4</span>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Width Ratio](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/bars/examples/width-ratio/)

```js
{
    series: [
        {
            type: 'range-bar',
            grouped: false,
            widthRatio: 0.4,
        },
    ],
}
```

In this example:

- The World series uses the default width ratio of 1.
- The Australia series has an initial width ratio of 0.4.
- Use the slider to change the width ratio.
- This gives an [Actual vs Target](https://www.ag-grid.com/charts/archive/14.2.0/react/bars/#actual-vs-target-bars) style visualisation, with the "World" series as a background reference.

## Actual vs Target Bars

Bars can be layered to create actual vs target comparisons by using `grouped: false` to overlay series.

#### Actual vs Target

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    title: {
      text: "Quarterly Sales vs Target",
    },
    series: [
      {
        type: "bar",
        direction: "horizontal",
        xKey: "quarter",
        yKey: "target",
        yName: "Target",
        grouped: false,
        fillOpacity: 0.3,
        cornerRadius: 3,
        highlight: {
          enabled: false,
        },
      },
      {
        type: "bar",
        direction: "horizontal",
        xKey: "quarter",
        yKey: "actual",
        yName: "Actual",
        grouped: false,
        widthRatio: 0.5,
        cornerRadius: 6,
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Actual vs Target](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/bars/examples/actual-target/)

```js
{
    series: [
        {
            type: 'bar',
            yKey: 'target',
            grouped: false,
            fillOpacity: 0.3,
        },
        {
            type: 'bar',
            yKey: 'actual',
            grouped: false,
            widthRatio: 0.5,
        },
    ],
}
```

In this example:

- The Target series uses `grouped: false` to span the full category width as a background bar.
- The Actual series also uses `grouped: false` with a `widthRatio` of 0.5 to appear narrower in front.
- The Target series is specified first in the `series` array so that it appears behind the Actual series.
- The target has reduced `fillOpacity` and highlighting disabled.

### Multiple Metrics

Multiple grouped series can be displayed over a single ungrouped target bar.

#### Multiple Metrics vs Target

```tsx
import React, { useState } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    title: {
      text: "Regional Sales vs Target",
    },
    series: [
      {
        type: "bar",
        xKey: "quarter",
        yKey: "target",
        yName: "Target",
        grouped: false,
        fillOpacity: 0.3,
        highlight: {
          enabled: false,
        },
      },
      {
        type: "bar",
        xKey: "quarter",
        yKey: "europe",
        yName: "Europe",
        widthRatio: 0.8,
      },
      {
        type: "bar",
        xKey: "quarter",
        yKey: "asia",
        yName: "Asia",
        widthRatio: 0.8,
      },
    ],
  });

  return <AgCharts options={options} />;
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Multiple Metrics vs Target](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/bars/examples/targets-comparisons/)

In this example:

- The "Target" series is ungrouped and spans the full category width as a background reference.
- The "Europe" and "Asia" series are grouped by default, sharing their portion of the category width.
- When a series has `grouped: false`, its `widthRatio` is relative to the full category width.
- When `grouped: true` (the default), `widthRatio` is relative to the automatically calculated width allocated to each series within group.

## Skip Null Bars

Use the `skipNullBars` option on a [Category](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-types/#category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/#unit-time) or [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/#ordinal-time) axis to prevent bars with `null`, `undefined` or missing values from taking up space within each category band. This also closes the gap when a series supplies its own `data` array and a category is absent from it.

#### Skip Null Bars

```tsx
import React, { useState, Fragment } from "react";
import { createRoot } from "react-dom/client";
import { AgCharts } from "ag-charts-react";
import {
  AgCartesianChartOptions,
  AgCategoryAxisOptions,
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = () => {
  const [options, setOptions] = useState<AgCartesianChartOptions>({
    data: getData(),
    title: {
      text: "Quarterly Revenue",
    },
    series: [
      {
        type: "bar",
        xKey: "quarter",
        yKey: "software",
        yName: "Software",
      },
      {
        type: "bar",
        xKey: "quarter",
        yKey: "hardware",
        yName: "Hardware",
      },
      {
        type: "bar",
        xKey: "quarter",
        yKey: "services",
        yName: "Services",
      },
      {
        type: "bar",
        xKey: "quarter",
        yKey: "investments",
        yName: "Investments",
      },
    ],
    axes: {
      x: {
        type: "category",
        skipNullBars: true,
      },
      y: {
        type: "number",
        label: {
          formatter: ({ value }) => `$${(value / 1000).toFixed(1)}B`,
        },
      },
    },
  });

  const skipNullBarsChange = (event: Event) => {
    const nextOptions = clone(options);

    (nextOptions.axes!.x as AgCategoryAxisOptions).skipNullBars =
      (event.target as HTMLInputElement).value === "true";

    setOptions(nextOptions);
  };

  return (
    <Fragment>
      <div className="example-controls">
        <div className="controls-row">
          <div
            className="button-group"
            role="group"
            aria-label="Skip Null Bars"
          >
            <input
              type="radio"
              id="skip-null-bars-on"
              name="skip-null-bars"
              defaultValue="true"
              defaultChecked
              onChange={(event) => skipNullBarsChange(event)}
            />
            <label htmlFor="skip-null-bars-on">Skip Null Bars</label>
            <input
              type="radio"
              id="skip-null-bars-off"
              name="skip-null-bars"
              defaultValue="false"
              onChange={(event) => skipNullBarsChange(event)}
            />
            <label htmlFor="skip-null-bars-off">Show Null Bars</label>
          </div>
        </div>
      </div>
      <AgCharts options={options} />
    </Fragment>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(<ChartExample />);
```

[Live example: Skip Null Bars](https://www.ag-grid.com/charts/archive/14.2.0/reactFunctionalTs/bars/examples/skip-null-bars/)

```js
{
    axes: {
        x: {
            type: 'category',
            skipNullBars: true,
        },
    },
}
```

In this example:

- Various values in the data are set to `null`, `undefined` or missing.
- When an axis has `skipNullBars: true`, bars with `null`, `undefined` or missing values are not represented on the chart.
- Toggle between "Skip Null Bars" and "Show Null Bars" to compare the difference.

## API Reference

#### Bar Options

These properties are common to [Bar](https://www.ag-grid.com/charts/archive/14.2.0/react/bar-series/), [Range Bar](https://www.ag-grid.com/charts/archive/14.2.0/react/range-bar-series/), [Waterfall](https://www.ag-grid.com/charts/archive/14.2.0/react/waterfall-series/) and [Box Plot](https://www.ag-grid.com/charts/archive/14.2.0/react/box-plot-series/) series types.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| width | PixelSize |  | Fixed width of each bar in the series. |
| widthRatio | Ratio |  | Ratio of the bandwidth (or specified width) to use for the width for each bar in the series. |
| cornerRadius | PixelSize |  | Apply rounded corners to each bar. |
| fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| fillOpacity | Opacity |  | The opacity of the fill colour. |
| stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |

#### Band Alignment

This property is available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-types/#category), [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/#ordinal-time) and [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/#unit-time) axes.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| bandAlignment | 'justify' \| 'start' \| 'center' \| 'end' | 'justify' | The alignment of bands when used with bar-like series with fixed widths. |

#### Skip Null Bars

This property is available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-types/#category), [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/#ordinal-time) and [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/react/axes-time/#unit-time) axes.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| skipNullBars | boolean | false | Set to `true` to prevent bars with `null`, `undefined` or missing values from taking up space in each category. |


---
product: "AG Charts"
title: "Series Bars"
description: "Angular charts support bar styling including fixed width, width ratio, band alignment and actual vs target visualisations."
framework: angular
version: "14.2.0"
related:
    - title: "Cross Lines"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-cross-lines/"
    - title: "Legend"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/legend/"
    - title: "Formatters"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/formatters/"
    - title: "Stylers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/stylers/"
    - title: "Series Fills"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/fills/"
    - title: "Series Labels"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/series-labels/"
    - title: "Series Markers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/markers/"
    - title: "Style Segments"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/style-segments/"
    - title: "Annotations"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/annotations/"
    - title: "Background Regions"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/background-regions/"
    - title: "Colour Scale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/colour-scale/"
    - title: "Error Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/angular/error-bars/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Series Bars

Data points can be represented by vertical or horizontal bars in many series types, such as [Bar](https://www.ag-grid.com/charts/archive/14.2.0/angular/bar-series/), [Range Bar](https://www.ag-grid.com/charts/archive/14.2.0/angular/range-bar-series/), [Waterfall](https://www.ag-grid.com/charts/archive/14.2.0/angular/waterfall-series/) and [Box Plot](https://www.ag-grid.com/charts/archive/14.2.0/angular/box-plot-series/).

Styling and customisation options such as `fill`, `stroke` and `cornerRadius` are configurable within each series. See [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/angular/bars/#api-reference) for details.

## Fixed Width

Use the `width` option to set a fixed pixel width for each bar.

#### Fixed Width

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Fixed Width](https://www.ag-grid.com/charts/archive/14.2.0/angular/bars/examples/fixed-width-clipping/)

```js
{
    series: [
        {
            type: 'bar',
            width: 30,
        },
    ],
}
```

In this example:

- Each bar in the series has a fixed width of 30 pixels.
- Toggle the fixed width off to let bars automatically size to fit the series area.
- Use the slider to change the width in pixels.

When using fixed width bars:

- Resizing the chart does not affect the width of the bars.
- The bars will be clipped if the fixed width exceeds the available space in the series area.
- Clipped bars can be viewed using the [Scrollbar](https://www.ag-grid.com/charts/archive/14.2.0/angular/scrollbar/), [Navigator](https://www.ag-grid.com/charts/archive/14.2.0/angular/navigator/) or [Zoom](https://www.ag-grid.com/charts/archive/14.2.0/angular/zoom/) controls.

### Band Alignment

Use the `bandAlignment` option on a [Category](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-types/#category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/#unit-time) or [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/#ordinal-time) axis to align fixed width bars.

#### Band Alignment

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Band Alignment](https://www.ag-grid.com/charts/archive/14.2.0/angular/bars/examples/band-alignment/)

```js
{
    axes: {
        x: {
            type: 'category',
            bandAlignment: 'start',
        },
    },
}
```

In this example:

- The category axis has an initial band alignment of `start`.
- Use the buttons to compare other band alignment options.
  - `justify` - bands are sized to fill the chart width, with the bars centred within each band.
  - `start` - bands are sized to fit the bar width and aligned to the start of the axis.
  - `center` - bands are sized to fit the bar width and centred within the chart width.
  - `end` - bands are sized to fit the bar width and aligned to the end of the axis.

## Width Ratio

Use the `widthRatio` option to set the bar width as a proportion of the default width.

#### Width Ratio

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Width Ratio](https://www.ag-grid.com/charts/archive/14.2.0/angular/bars/examples/width-ratio/)

```js
{
    series: [
        {
            type: 'range-bar',
            grouped: false,
            widthRatio: 0.4,
        },
    ],
}
```

In this example:

- The World series uses the default width ratio of 1.
- The Australia series has an initial width ratio of 0.4.
- Use the slider to change the width ratio.
- This gives an [Actual vs Target](https://www.ag-grid.com/charts/archive/14.2.0/angular/bars/#actual-vs-target-bars) style visualisation, with the "World" series as a background reference.

## Actual vs Target Bars

Bars can be layered to create actual vs target comparisons by using `grouped: false` to overlay series.

#### Actual vs Target

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Actual vs Target](https://www.ag-grid.com/charts/archive/14.2.0/angular/bars/examples/actual-target/)

```js
{
    series: [
        {
            type: 'bar',
            yKey: 'target',
            grouped: false,
            fillOpacity: 0.3,
        },
        {
            type: 'bar',
            yKey: 'actual',
            grouped: false,
            widthRatio: 0.5,
        },
    ],
}
```

In this example:

- The Target series uses `grouped: false` to span the full category width as a background bar.
- The Actual series also uses `grouped: false` with a `widthRatio` of 0.5 to appear narrower in front.
- The Target series is specified first in the `series` array so that it appears behind the Actual series.
- The target has reduced `fillOpacity` and highlighting disabled.

### Multiple Metrics

Multiple grouped series can be displayed over a single ungrouped target bar.

#### Multiple Metrics vs Target

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Multiple Metrics vs Target](https://www.ag-grid.com/charts/archive/14.2.0/angular/bars/examples/targets-comparisons/)

In this example:

- The "Target" series is ungrouped and spans the full category width as a background reference.
- The "Europe" and "Asia" series are grouped by default, sharing their portion of the category width.
- When a series has `grouped: false`, its `widthRatio` is relative to the full category width.
- When `grouped: true` (the default), `widthRatio` is relative to the automatically calculated width allocated to each series within group.

## Skip Null Bars

Use the `skipNullBars` option on a [Category](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-types/#category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/#unit-time) or [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/#ordinal-time) axis to prevent bars with `null`, `undefined` or missing values from taking up space within each category band. This also closes the gap when a series supplies its own `data` array and a category is absent from it.

#### Skip Null Bars

```ts
// Angular entry point file
import '@angular/compiler';
import { bootstrapApplication } from '@angular/platform-browser';

import { AppComponent } from './app.component';

bootstrapApplication(AppComponent);
```

[Live example: Skip Null Bars](https://www.ag-grid.com/charts/archive/14.2.0/angular/bars/examples/skip-null-bars/)

```js
{
    axes: {
        x: {
            type: 'category',
            skipNullBars: true,
        },
    },
}
```

In this example:

- Various values in the data are set to `null`, `undefined` or missing.
- When an axis has `skipNullBars: true`, bars with `null`, `undefined` or missing values are not represented on the chart.
- Toggle between "Skip Null Bars" and "Show Null Bars" to compare the difference.

## API Reference

#### Bar Options

These properties are common to [Bar](https://www.ag-grid.com/charts/archive/14.2.0/angular/bar-series/), [Range Bar](https://www.ag-grid.com/charts/archive/14.2.0/angular/range-bar-series/), [Waterfall](https://www.ag-grid.com/charts/archive/14.2.0/angular/waterfall-series/) and [Box Plot](https://www.ag-grid.com/charts/archive/14.2.0/angular/box-plot-series/) series types.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| width | PixelSize |  | Fixed width of each bar in the series. |
| widthRatio | Ratio |  | Ratio of the bandwidth (or specified width) to use for the width for each bar in the series. |
| cornerRadius | PixelSize |  | Apply rounded corners to each bar. |
| fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| fillOpacity | Opacity |  | The opacity of the fill colour. |
| stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |

#### Band Alignment

This property is available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-types/#category), [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/#ordinal-time) and [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/#unit-time) axes.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| bandAlignment | 'justify' \| 'start' \| 'center' \| 'end' | 'justify' | The alignment of bands when used with bar-like series with fixed widths. |

#### Skip Null Bars

This property is available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-types/#category), [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/#ordinal-time) and [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/angular/axes-time/#unit-time) axes.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| skipNullBars | boolean | false | Set to `true` to prevent bars with `null`, `undefined` or missing values from taking up space in each category. |


---
product: "AG Charts"
title: "Series Bars"
description: "Vue charts support bar styling including fixed width, width ratio, band alignment and actual vs target visualisations."
framework: vue
version: "14.2.0"
related:
    - title: "Cross Lines"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-cross-lines/"
    - title: "Legend"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/legend/"
    - title: "Formatters"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/formatters/"
    - title: "Stylers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/stylers/"
    - title: "Series Fills"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/fills/"
    - title: "Series Labels"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/series-labels/"
    - title: "Series Markers"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/markers/"
    - title: "Style Segments"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/style-segments/"
    - title: "Annotations"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/annotations/"
    - title: "Background Regions"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/background-regions/"
    - title: "Colour Scale"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/colour-scale/"
    - title: "Error Bars"
      url: "https://www.ag-grid.com/charts/archive/14.2.0/vue/error-bars/"
llms: "https://www.ag-grid.com/charts/archive/14.2.0/llms.txt"
---

# Series Bars

Data points can be represented by vertical or horizontal bars in many series types, such as [Bar](https://www.ag-grid.com/charts/archive/14.2.0/vue/bar-series/), [Range Bar](https://www.ag-grid.com/charts/archive/14.2.0/vue/range-bar-series/), [Waterfall](https://www.ag-grid.com/charts/archive/14.2.0/vue/waterfall-series/) and [Box Plot](https://www.ag-grid.com/charts/archive/14.2.0/vue/box-plot-series/).

Styling and customisation options such as `fill`, `stroke` and `cornerRadius` are configurable within each series. See [API Reference](https://www.ag-grid.com/charts/archive/14.2.0/vue/bars/#api-reference) for details.

## Fixed Width

Use the `width` option to set a fixed pixel width for each bar.

#### Fixed Width

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  ScrollbarModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
  ScrollbarModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <span>Bar Width:</span>
        <div class="button-group" role="group" aria-label="Bar Width">
          <input type="radio" id="width-auto" name="width" value="auto" v-on:change="setWidthMode($event)">
            <label for="width-auto">Auto</label>
            <input type="radio" id="width-fixed" name="width" value="fixed" checked="" v-on:change="setWidthMode($event)">
              <label for="width-fixed">Fixed</label>
            </div>
            <fieldset id="fixedWidthGroup" class="control-group">
              <label for="fixedWidthSliderInput" class="gap-left">Fixed Width:</label>
              <input type="range" id="fixedWidthSliderInput" min="5" max="60" value="30" step="1" v-on:input="updateFixedWidth($event)" v-on:change="updateFixedWidth($event)">
                <span id="fixedWidthSliderValue">30</span>
              </fieldset>
            </div>
          </div>
          <ag-charts
            :options="options"
          />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      title: {
        text: "Quarterly Revenue by Product Line",
      },
      scrollbar: { enabled: true },
      series: [
        {
          type: "bar",
          xKey: "quarter",
          yKey: "software",
          yName: "Software",
          width: 30,
        },
        {
          type: "bar",
          xKey: "quarter",
          yKey: "hardware",
          yName: "Hardware",
          width: 30,
        },
        {
          type: "bar",
          xKey: "quarter",
          yKey: "services",
          yName: "Services",
          width: 30,
        },
      ],
      axes: {
        x: {
          type: "category",
        },
        y: {
          type: "number",
          label: {
            formatter: ({ value }) => `$${(value / 1000).toFixed(1)}B`,
          },
        },
      },
    });

    const setWidthMode = (event) => {
      const optionsCopy = clone(options.value);

      const fixedWidth = event.target.value === "fixed";
      for (const series of optionsCopy.series ?? []) {
        if (!("width" in series)) continue;
        series.width = fixedWidth
          ? Number(document.getElementById("fixedWidthSliderValue").innerHTML)
          : undefined;
      }

      document.getElementById("fixedWidthGroup").disabled = !fixedWidth;

      options.value = optionsCopy;
    };
    const updateFixedWidth = (event) => {
      const optionsCopy = clone(options.value);

      const value = Number(event.target?.value);
      for (const series of optionsCopy.series ?? []) {
        if (!("width" in series)) continue;
        series.width = value;
      }

      document.getElementById("fixedWidthSliderValue").innerHTML =
        String(value);

      options.value = optionsCopy;
    };

    return {
      options,
      setWidthMode,
      updateFixedWidth,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Fixed Width](https://www.ag-grid.com/charts/archive/14.2.0/vue3/bars/examples/fixed-width-clipping/)

```js
{
    series: [
        {
            type: 'bar',
            width: 30,
        },
    ],
}
```

In this example:

- Each bar in the series has a fixed width of 30 pixels.
- Toggle the fixed width off to let bars automatically size to fit the series area.
- Use the slider to change the width in pixels.

When using fixed width bars:

- Resizing the chart does not affect the width of the bars.
- The bars will be clipped if the fixed width exceeds the available space in the series area.
- Clipped bars can be viewed using the [Scrollbar](https://www.ag-grid.com/charts/archive/14.2.0/vue/scrollbar/), [Navigator](https://www.ag-grid.com/charts/archive/14.2.0/vue/navigator/) or [Zoom](https://www.ag-grid.com/charts/archive/14.2.0/vue/zoom/) controls.

### Band Alignment

Use the `bandAlignment` option on a [Category](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-types/#category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/#unit-time) or [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/#ordinal-time) axis to align fixed width bars.

#### Band Alignment

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group" role="group" aria-label="Band Alignment">
          <input type="radio" id="band-alignment-justify" name="band-alignment" value="justify" v-on:change="bandAlignmentChange($event)">
            <label for="band-alignment-justify">Justify</label>
            <input type="radio" id="band-alignment-start" name="band-alignment" value="start" checked="" v-on:change="bandAlignmentChange($event)">
              <label for="band-alignment-start">Start</label>
              <input type="radio" id="band-alignment-center" name="band-alignment" value="center" v-on:change="bandAlignmentChange($event)">
                <label for="band-alignment-center">Center</label>
                <input type="radio" id="band-alignment-end" name="band-alignment" value="end" v-on:change="bandAlignmentChange($event)">
                  <label for="band-alignment-end">End</label>
                </div>
              </div>
            </div>
            <ag-charts
              :options="options"
            />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions<DataType>>({
      data: getData(),
      title: {
        text: "Total Visitors to Museums and Galleries",
      },
      footnote: {
        text: "Source: Department for Digital, Culture, Media & Sport",
      },
      series: [
        {
          type: "bar",
          xKey: "quarter",
          yKey: "museums",
          yName: "Museums",
          width: 10,
        },
        {
          type: "bar",
          xKey: "quarter",
          yKey: "galleries",
          yName: "Galleries",
          width: 10,
        },
        {
          type: "bar",
          xKey: "quarter",
          yKey: "heritage",
          yName: "Heritage Sites",
          width: 10,
        },
      ],
      axes: {
        x: {
          type: "category",
          bandAlignment: "start",
        },
        y: {
          type: "number",
          title: {
            text: "Total Visitors (Millions)",
          },
        },
      },
      formatter: {
        y(params) {
          const value = params.value;
          const millions = value / 1000000;
          const accuracy = ["series-label", "axis-label"].includes(
            params.source,
          )
            ? 0
            : 1;
          return `${millions.toFixed(accuracy)}M`;
        },
      },
    });

    const bandAlignmentChange = (event) => {
      const optionsCopy = clone(options.value);

      const alignment = event.target.value;
      optionsCopy.axes.x.bandAlignment = alignment;

      options.value = optionsCopy;
    };

    return {
      options,
      bandAlignmentChange,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Band Alignment](https://www.ag-grid.com/charts/archive/14.2.0/vue3/bars/examples/band-alignment/)

```js
{
    axes: {
        x: {
            type: 'category',
            bandAlignment: 'start',
        },
    },
}
```

In this example:

- The category axis has an initial band alignment of `start`.
- Use the buttons to compare other band alignment options.
  - `justify` - bands are sized to fill the chart width, with the bars centred within each band.
  - `start` - bands are sized to fit the bar width and aligned to the start of the axis.
  - `center` - bands are sized to fit the bar width and centred within the chart width.
  - `end` - bands are sized to fit the bar width and aligned to the end of the axis.

## Width Ratio

Use the `widthRatio` option to set the bar width as a proportion of the default width.

#### Width Ratio

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  CrosshairModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
  RangeBarSeriesModule,
  UnitTimeAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

const data = getData();

ModuleRegistry.registerModules([
  CrosshairModule,
  LegendModule,
  NumberAxisModule,
  RangeBarSeriesModule,
  UnitTimeAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <label for="widthRatioSliderInput">Width Ratio:</label>
        <input type="range" id="widthRatioSliderInput" min="0.1" max="1.0" value="0.4" step="0.1" v-on:input="updateWidthRatio($event)" v-on:change="updateWidthRatio($event)">
          <span id="widthRatioSliderValue">0.4</span>
        </div>
      </div>
      <ag-charts
        :options="options"
      />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      title: {
        text: "Australia vs Global Temperature Patterns",
      },
      subtitle: {
        text: "Monthly temperature ranges (2020) showing seasonal variations across regions",
      },
      footnote: {
        text: "Data: World Meteorological Organization. Ranges show typical monthly lows and highs.",
        fontStyle: "italic",
      },
      series: [
        {
          data: data.World,
          type: "range-bar",
          xKey: "month",
          yName: "World",
          yLowKey: "lowTemperature",
          yHighKey: "highTemperature",
          yLowName: "Min Temp",
          yHighName: "Max Temp",
          cornerRadius: 5,
          fill: "transparent",
          strokeWidth: 2,
          strokeOpacity: 0.6,
          highlight: { enabled: false },
        },
        {
          data: data.Australia,
          type: "range-bar",
          xKey: "month",
          yName: "Australia",
          grouped: false,
          widthRatio: 0.4,
          yLowKey: "lowTemperature",
          yHighKey: "highTemperature",
          yLowName: "Min Temp",
          yHighName: "Max Temp",
          cornerRadius: 5,
        },
      ],
      axes: {
        x: {
          type: "unit-time",
          label: {
            formatter: ({ value }) => {
              const date = new Date(value);
              return date.toLocaleDateString("en-US", { month: "short" });
            },
          },
        },
        y: {
          label: {
            formatter: ({ value }) => `${value}°C`,
          },
        },
      },
    });

    const updateWidthRatio = (event) => {
      const optionsCopy = clone(options.value);

      const value = Number(event.target?.value);
      optionsCopy.series[1].widthRatio = value;

      document.getElementById("widthRatioSliderValue").innerHTML =
        String(value);

      options.value = optionsCopy;
    };

    return {
      options,
      updateWidthRatio,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Width Ratio](https://www.ag-grid.com/charts/archive/14.2.0/vue3/bars/examples/width-ratio/)

```js
{
    series: [
        {
            type: 'range-bar',
            grouped: false,
            widthRatio: 0.4,
        },
    ],
}
```

In this example:

- The World series uses the default width ratio of 1.
- The Australia series has an initial width ratio of 0.4.
- Use the slider to change the width ratio.
- This gives an [Actual vs Target](https://www.ag-grid.com/charts/archive/14.2.0/vue/bars/#actual-vs-target-bars) style visualisation, with the "World" series as a background reference.

## Actual vs Target Bars

Bars can be layered to create actual vs target comparisons by using `grouped: false` to overlay series.

#### Actual vs Target

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      title: {
        text: "Quarterly Sales vs Target",
      },
      series: [
        {
          type: "bar",
          direction: "horizontal",
          xKey: "quarter",
          yKey: "target",
          yName: "Target",
          grouped: false,
          fillOpacity: 0.3,
          cornerRadius: 3,
          highlight: {
            enabled: false,
          },
        },
        {
          type: "bar",
          direction: "horizontal",
          xKey: "quarter",
          yKey: "actual",
          yName: "Actual",
          grouped: false,
          widthRatio: 0.5,
          cornerRadius: 6,
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Actual vs Target](https://www.ag-grid.com/charts/archive/14.2.0/vue3/bars/examples/actual-target/)

```js
{
    series: [
        {
            type: 'bar',
            yKey: 'target',
            grouped: false,
            fillOpacity: 0.3,
        },
        {
            type: 'bar',
            yKey: 'actual',
            grouped: false,
            widthRatio: 0.5,
        },
    ],
}
```

In this example:

- The Target series uses `grouped: false` to span the full category width as a background bar.
- The Actual series also uses `grouped: false` with a `widthRatio` of 0.5 to appear narrower in front.
- The Target series is specified first in the `series` array so that it appears behind the Actual series.
- The target has reduced `fillOpacity` and highlighting disabled.

### Multiple Metrics

Multiple grouped series can be displayed over a single ungrouped target bar.

#### Multiple Metrics vs Target

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-community";
import { getData } from "./data";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <ag-charts
      :options="options"
    />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      title: {
        text: "Regional Sales vs Target",
      },
      series: [
        {
          type: "bar",
          xKey: "quarter",
          yKey: "target",
          yName: "Target",
          grouped: false,
          fillOpacity: 0.3,
          highlight: {
            enabled: false,
          },
        },
        {
          type: "bar",
          xKey: "quarter",
          yKey: "europe",
          yName: "Europe",
          widthRatio: 0.8,
        },
        {
          type: "bar",
          xKey: "quarter",
          yKey: "asia",
          yName: "Asia",
          widthRatio: 0.8,
        },
      ],
    });

    return {
      options,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Multiple Metrics vs Target](https://www.ag-grid.com/charts/archive/14.2.0/vue3/bars/examples/targets-comparisons/)

In this example:

- The "Target" series is ungrouped and spans the full category width as a background reference.
- The "Europe" and "Asia" series are grouped by default, sharing their portion of the category width.
- When a series has `grouped: false`, its `widthRatio` is relative to the full category width.
- When `grouped: true` (the default), `widthRatio` is relative to the automatically calculated width allocated to each series within group.

## Skip Null Bars

Use the `skipNullBars` option on a [Category](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-types/#category), [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/#unit-time) or [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/#ordinal-time) axis to prevent bars with `null`, `undefined` or missing values from taking up space within each category band. This also closes the gap when a series supplies its own `data` array and a category is absent from it.

#### Skip Null Bars

```ts
import { createApp, defineComponent, ref } from "vue";
import { AgCharts } from "ag-charts-vue3";
import type { AgChartOptions } from "ag-charts-types";
import {
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  ModuleRegistry,
  NumberAxisModule,
} from "ag-charts-enterprise";
import { getData } from "./data";
import clone from "clone";

ModuleRegistry.registerModules([
  BarSeriesModule,
  CategoryAxisModule,
  LegendModule,
  NumberAxisModule,
]);

const ChartExample = defineComponent({
  template: `
    <div class="example-controls">
      <div class="controls-row">
        <div class="button-group" role="group" aria-label="Skip Null Bars">
          <input type="radio" id="skip-null-bars-on" name="skip-null-bars" value="true" checked="" v-on:change="skipNullBarsChange($event)">
            <label for="skip-null-bars-on">Skip Null Bars</label>
            <input type="radio" id="skip-null-bars-off" name="skip-null-bars" value="false" v-on:change="skipNullBarsChange($event)">
              <label for="skip-null-bars-off">Show Null Bars</label>
            </div>
          </div>
        </div>
        <ag-charts
          :options="options"
        />
  `,
  components: {
    "ag-charts": AgCharts,
  },
  setup(props) {
    const options = ref<AgCartesianChartOptions>({
      data: getData(),
      title: {
        text: "Quarterly Revenue",
      },
      series: [
        {
          type: "bar",
          xKey: "quarter",
          yKey: "software",
          yName: "Software",
        },
        {
          type: "bar",
          xKey: "quarter",
          yKey: "hardware",
          yName: "Hardware",
        },
        {
          type: "bar",
          xKey: "quarter",
          yKey: "services",
          yName: "Services",
        },
        {
          type: "bar",
          xKey: "quarter",
          yKey: "investments",
          yName: "Investments",
        },
      ],
      axes: {
        x: {
          type: "category",
          skipNullBars: true,
        },
        y: {
          type: "number",
          label: {
            formatter: ({ value }) => `$${(value / 1000).toFixed(1)}B`,
          },
        },
      },
    });

    const skipNullBarsChange = (event) => {
      const optionsCopy = clone(options.value);

      optionsCopy.axes.x.skipNullBars = event.target.value === "true";

      options.value = optionsCopy;
    };

    return {
      options,
      skipNullBarsChange,
    };
  },
});

createApp(ChartExample).mount("#app");
```

[Live example: Skip Null Bars](https://www.ag-grid.com/charts/archive/14.2.0/vue3/bars/examples/skip-null-bars/)

```js
{
    axes: {
        x: {
            type: 'category',
            skipNullBars: true,
        },
    },
}
```

In this example:

- Various values in the data are set to `null`, `undefined` or missing.
- When an axis has `skipNullBars: true`, bars with `null`, `undefined` or missing values are not represented on the chart.
- Toggle between "Skip Null Bars" and "Show Null Bars" to compare the difference.

## API Reference

#### Bar Options

These properties are common to [Bar](https://www.ag-grid.com/charts/archive/14.2.0/vue/bar-series/), [Range Bar](https://www.ag-grid.com/charts/archive/14.2.0/vue/range-bar-series/), [Waterfall](https://www.ag-grid.com/charts/archive/14.2.0/vue/waterfall-series/) and [Box Plot](https://www.ag-grid.com/charts/archive/14.2.0/vue/box-plot-series/) series types.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| width | PixelSize |  | Fixed width of each bar in the series. |
| widthRatio | Ratio |  | Ratio of the bandwidth (or specified width) to use for the width for each bar in the series. |
| cornerRadius | PixelSize |  | Apply rounded corners to each bar. |
| fill | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor \| AgGradientColor \| AgPatternColor \| AgImageFill |  | The colour for filling shapes. A colour string, or an object for a gradient, pattern, or image fill. |
| fillOpacity | Opacity |  | The opacity of the fill colour. |
| stroke | CssColor \| AgColorRef \| AgColorRefMixOnto \| AgColorRefMixOntoColor |  | The colour for the stroke. |
| strokeWidth | PixelSize |  | The width of the stroke in pixels. |
| strokeOpacity | Opacity |  | The opacity of the stroke colour. |
| lineDash | PixelSize[] |  | An array specifying the length in pixels of alternating dashes and gaps. |
| lineDashOffset | PixelSize |  | The initial offset of the dashed line in pixels. |

#### Band Alignment

This property is available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-types/#category), [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/#ordinal-time) and [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/#unit-time) axes.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| bandAlignment | 'justify' \| 'start' \| 'center' \| 'end' | 'justify' | The alignment of bands when used with bar-like series with fixed widths. |

#### Skip Null Bars

This property is available on [Category](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-types/#category), [Ordinal Time](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/#ordinal-time) and [Unit Time](https://www.ag-grid.com/charts/archive/14.2.0/vue/axes-time/#unit-time) axes.

| Property | Type | Default | Description |
| --- | --- | --- | --- |
| skipNullBars | boolean | false | Set to `true` to prevent bars with `null`, `undefined` or missing values from taking up space in each category. |
